<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="98px">
      <el-form-item label="费用项目编码" prop="feeItemCode">
        <el-input
          v-model="queryParams.feeItemCode"
          placeholder="请输入费用项目编码"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="费用项目名称" prop="feeItemName">
        <el-input
          v-model="queryParams.feeItemName"
          placeholder="请输入费用项目名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="渠道" prop="feeItemCategory">
        <el-select
          v-model="queryParams.feeItemCategory"
          placeholder="请选择渠道"
          clearable
        >
          <el-option
            v-for="dict in logistics_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="外部费用编码" prop="extFeeCode">
        <el-input
          v-model="queryParams.extFeeCode"
          placeholder="请输入外部费用编码"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="外部费用名称" prop="extFeeName">
        <el-input
          v-model="queryParams.extFeeName"
          placeholder="请输入外部费用名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['system:inancialFee:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:inancialFee:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:inancialFee:remove']"
        >删除</el-button>
      </el-col>
<!--      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['system:inancialFee:export']"
        >导出</el-button>
      </el-col>-->
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="inancialFeeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="费用项目编码" align="center" prop="feeItemCode" />
      <el-table-column label="费用项目名称" align="center" prop="feeItemName" />
      <el-table-column label="渠道" align="center" prop="feeItemCategory">
        <template #default="scope">
          <dict-tag :options="logistics_type" :value="scope.row.feeItemCategory" />
        </template>
      </el-table-column>
      <el-table-column label="外部费用编码" align="center" prop="extFeeCode" />
      <el-table-column label="外部费用名称" align="center" prop="extFeeName" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
<!--      <el-table-column label="备注" align="center" prop="remark" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:inancialFee:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:inancialFee:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改费用类型管理对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="inancialFeeRef" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="费用项目编码" prop="feeItemCode">
          <el-input v-model="form.feeItemCode" placeholder="请输入费用项目编码" />
        </el-form-item>
        <el-form-item label="费用项目名称" prop="feeItemName">
          <el-input v-model="form.feeItemName" placeholder="请输入费用项目名称" />
        </el-form-item>
        <el-form-item label="外部渠道" prop="feeItemCategory">
          <el-select v-model="form.feeItemCategory" placeholder="请选择外部渠道">
            <el-option
              v-for="dict in logistics_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="外部费用编码" prop="extFeeCode">
          <el-input v-model="form.extFeeCode" placeholder="请输入外部费用编码" />
        </el-form-item>
        <el-form-item label="外部费用名称" prop="extFeeName">
          <el-input v-model="form.extFeeName" placeholder="请输入外部费用名称" />
        </el-form-item>
<!--        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>-->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="InancialFee">
import { listInancialFee, getInancialFee, delInancialFee, addInancialFee, updateInancialFee } from "@/api/logistics/inancialFee"
import DictTag from '@/components/DictTag'
import { useDict } from '@/utils/dict'

const { proxy } = getCurrentInstance()

// 使用物流类型字典
const { logistics_type } = proxy.useDict("logistics_type")

const inancialFeeList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    feeItemCode: null,
    feeItemName: null,
    feeItemCategory: null,  // 外部渠道字段
    extFeeCode: null,
    extFeeName: null,
    deptId: null,
    userId: null,
  },
  rules: {
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询费用类型管理列表 */
function getList() {
  loading.value = true
  listInancialFee(queryParams.value).then(response => {
    inancialFeeList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    feeItemId: null,
    feeItemCode: null,
    feeItemName: null,
    feeItemCategory: null,  // 外部渠道字段
    extFeeCode: null,
    extFeeName: null,
    createTime: null,
    updateTime: null,
    remark: null,
    deptId: null,
    userId: null,
    delFlag: null,
    createBy: null,
    updateBy: null
  }
  proxy.resetForm("inancialFeeRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.feeItemId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加费用类型管理"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _feeItemId = row.feeItemId || ids.value
  getInancialFee(_feeItemId).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改费用类型管理"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["inancialFeeRef"].validate(valid => {
    if (valid) {
      if (form.value.feeItemId != null) {
        updateInancialFee(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addInancialFee(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _feeItemIds = row.feeItemId || ids.value
  proxy.$modal.confirm('是否确认删除费用类型管理编号为"' + _feeItemIds + '"的数据项？').then(function() {
    return delInancialFee(_feeItemIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('system/inancialFee/export', {
    ...queryParams.value
  }, `inancialFee_${new Date().getTime()}.xlsx`)
}

getList()
</script>
